<?php
/**
 * Celebrio Database module
 * 
 * @copyright  Copyright (c) 2011 Celebrio Software
 * @package    Celebrio
 * @subpackage Database
 */
namespace Celebrio\Database;

use Celebrio\Database\IDatabase;

/**
 * Azure
 *
 * @author     Albireo Solutions
 * @package    Kernel
 */
class Azure extends DatabaseDriver implements IDatabase {
    
    public function createLogin ( $username, $pass, $newUser = true) {
        $init = new AzureInit();
        $init->createLogin($username, $pass, $newUser);
    }

    public function deleteLogin ( $username ) {
        $init = new AzureInit();
        $init->deleteLogin($username);
    }

    /* --------------- DataBase Functions (DBF) ------------------------ */
    
    public function dbfConcat($first, $second) {
        return $first . " + " . $second;
    }

    public function dbfSubstr($string, $from, $for = null) {
        if ($for === null) {
            return "substring(" . $string . ", " . $from . ", " . $this->dbfStrlen($string) . ")";
        } else {
            return "substring(" . $string . ", " . $from . ", " . $for . ")";
        }
    }

    public function dbfStrlen($string) {
        return "len(" . $string . ")";
    }


}
