<?php
/**
 * Celebrio Database module
 * 
 * @copyright  Copyright (c) 2011 Celebrio Software
 * @package    Celebrio
 * @subpackage Database
 */
namespace Celebrio\Database;

use Celebrio\Database\IDatabase;

/**
 * Azure
 *
 * @author     Albireo Solutions
 * @package    Kernel
 */
class MSSQL extends DatabaseDriver implements IDatabase {

    public function createLogin ( $username, $pass, $newUser = true) {
        $init = new MSSQLInit();
        $init->createLogin($username, $pass, $newUser);
    }

    public function deleteLogin ( $username ) {
        $init = new MSSQLInit();
        $init->deleteLogin($username);
    }

    /* --------------- DataBase Functions (DBF) ------------------------ */
    
    public function dbfConcat($first, $second) {
        return $first . " + " . $second;
    }

    public function dbfStrlen($string) {
        return "len(" . $string . ")";
    }


}
