-- Creates table azure-name
CREATE TABLE "azure_files"(
 "id_azure_file" Serial NOT NULL,
 "id_file" Integer NOT NULL
 "name_azure_file" Character(128) NOT NULL)
)
WITH (OIDS=FALSE)
;

-- Add keys for table azure-name

ALTER TABLE "azure_files" ADD CONSTRAINT "azure_files_pk" PRIMARY KEY ("id_azure_file")
;

ALTER TABLE "azure_files" ADD CONSTRAINT "files_azure_files" FOREIGN KEY ("id_file") REFERENCES "files" ("id_file") ON DELETE CASCADE ON UPDATE CASCADE
;